# Reddit Realtime

This is a PCMRBot.js module that integrates into the Pushshift Reddit SSE stream and creates realtime streams of other Reddit services.

At the current time, it is suggested that only one instance of the Reddit RT module runs per cluster. 

## Dependencies

This module has the following dependencies: 

* [`core/reddit`](https://gitlab.com/pcmasterrace/pcmrbot.js/core/utilities), version 1

## Environment variables

The following environment variables should be set prior to launch. 

* Module options
  * `REDDIT_RT_SUBREDDIT` - The name of the subreddit to watch
  * (optional) `REDDIT_RT_USE_POSTS` - Whether to enable the Posts RT module. Defaults to false
  * (optional) `REDDIT_RT_POSTS_ALLSUBREDDITS` - Whether the Posts RT module should emit events for all subreddits, not just the specified one. **WARNING** - Depending on Reddit traffic, this will drastically increase network utilization and CPU load. Defaults to false
  * (optional) `REDDIT_RT_USE_MODLOG` - Whether to enable the Modlog RT module. Defaults to false
  * (optional) `REDDIT_RT_MODLOG_INTERVAL` - Interval between modlog checks, in milliseconds. Defaults to `60000` (60 seconds)
  * (optional) `REDDIT_RT_USE_MODQUEUE` - Whether to enable the Modqueue RT module. Defaults to false
  * (optional) `REDDIT_RT_MODQUEUE_INTERVAL` - Interval between modqueue checks, in milliseconds. Defaults to `60000` (60 seconds)
* Database options ([options passed directly into Sequelize](http://docs.sequelizejs.com/manual/installation/usage.html))
  * `REDDIT_RT_DB_DIALECT` - The database dialect to use
  * `REDDIT_RT_DB_HOST` - The database hostname to connect to
  * `REDDIT_RT_DB_NAME` - The database name to connect to
  * `REDDIT_RT_DB_USERNAME` - The database username
  * `REDDIT_RT_DB_PASSWORD` - The database password
  * `REDDIT_RT_DB_PORT` - The database port
  * `REDDIT_RT_DB_PATH` - (SQLite only) The database path on the filesystem
  * (optional) `REDDIT_RT_DB_DROP_TABLES_ON_START` - Whether the tables used should be cleaned at launch. Defaults to false
* Broker options
  * (optional) `TRANSPORT_NODE_ID` - The node ID that should be used for connecting to the rest of the cluster. Defaults to the system hostname plus a random number string. 
  * (optional) `TRANSPORT_BIND_ADDRESS` - The network address that the service broker should bind to. Defaults to all available addresses across all network interfaces.

# API Reference 

{{>main}}